package handler

import (
	"context"
	"net/http"

	httpsrv "go.unistack.org/micro-server-http/v3"
	"go.unistack.org/pkgdash/internal/models"
	pb "go.unistack.org/pkgdash/proto"
)

func (h *Handler) PackageList(ctx context.Context, req *pb.PackageListReq, rsp *pb.PackageListRsp) error {
	h.logger.Debug(ctx, "PackagesList handler start")

	packages, err := h.store.PackageList(ctx, req)
	if err != nil {
		h.logger.Error(ctx, "error db response: %v", err)
		httpsrv.SetRspCode(ctx, http.StatusInternalServerError)
		return httpsrv.SetError(NewInternalError(err))
	}

	for _, pkg := range packages {
		rsp.Packages = append(rsp.Packages, models.NewPackage(pkg))
	}
	h.logger.Debug(ctx, "PackagesList handler stop")
	return nil
}
